;; Pftpshell mirc script
;; v2.1-FINAL by leprechau
;; 11.21.2003

; formatting crap
alias pftp_sdisp { if ($1- != $null) { echo -s $chr(42) $+ $chr(42) $+ $chr(42) $+ $chr(32) $+ $1- } }
alias pftp_disp { if ($1- != $null) { echo -a $chr(42) $+ $chr(42) $+ $chr(42) $+ $chr(32) $+ $1- } }
alias pftp_cfp { if ($1- != $null) { return $chr(2) $+ ( $+ $chr(2) $+ $1- $+ $chr(2) $+ ) $+ $chr(2) } }
alias pftp_cfb { if ($1- != $null) { return $chr(2) $+ $chr(91) $+ $chr(2) $+ $1- $+ $chr(2) $+ $chr(93) $+ $chr(2) } }

;; /con quick launch alias
alias con {
   if ($1- == $null) { pftp_disp Command Syntax: /con $chr(91) $+ -section $+ $chr(93) site1 site2 site3 site4 site5 ... | halt }
   if ($left($1,1) == $chr(45)) {
      var %section = $remove($upper($1),$chr(45))
      var %sites = $replace($upper($2-),$chr(32),$chr(44))
   }
   else {
      var %section = NA
      var %sites = $replace($upper($1-),$chr(32),$chr(44))
   }
   set %pftpline -passwd= $+ %PftpPassword $+ $chr(32) $+ -section= $+ %section $+ $chr(32) $+ -connect= $+ %sites
   put_pftp %pftpline
   pftp_disp Launching pftp with: %pftpline
   if ($window(@pftp-server,status) == 0) { window -R +Le @pftp-server }
   aline -p 14 @pftp-server Launching pftp with: %pftpline
}

;; pftp control alias
alias pftp {
   if ($1 == $null) { 
      pftp_disp Command Syntax: /pftp <start|stop|rehash|race>
      halt
   }
   elseif (($1 == start) && (%PftpScriptActive === NO)) {
      set %PftpScriptActive YES
      pftp_disp Script Active '/pftp stop' to deactivate
      halt
   }
   elseif ($1 == start) && (%PftpScriptActive === YES) {
      pftp_disp Script Already Active '/pftp stop' to deactivate
      halt
   }
   elseif (($1 == stop) && (%PftpScriptActive === YES)) {
      set %PftpScriptActive NO
      pftp_disp Script Deactivated '/pftp start' to activate
      halt
   }
   elseif (($1 == stop) && (%PftpScriptActive === NO)) {
      set %PftpScriptActive YES
      pftp_disp Script Already Dectivated '/pftp start' to activate
      halt
   }
   elseif ($1 == rehash) {
      pftp_disp Rehashing variables and tables...
      if ($hget(pftp_matches).size != 0) { hfree pftp_matches }
      if ($hget(pftp_execlines).size != 0) { hfree pftp_execlines }
      if ($hget(pftp_bots).size != 0) { hfree pftp_bots }
      if ($hget(pftp_ignores).size != 0) { hfree pftp_ignores }
      if ($hget(pftp_nonconn_ignores).size != 0) { hfree pftp_nonconn_ignores }
      if ($hget(pftp_nonconn_matches).size != 0) { hfree pftp_nonconn_matches }
      if ($hget(pftp_notes).size != 0) { hfree pftp_notes }
      if ($hget(pftp_race_ignores).size != 0) { hfree pftp_race_ignores }
      if ($hget(pftp_race_chan_ignores).size != 0) { hfree pftp_race_chan_ignores }
      if ($exists(pftp_matches.htbl)) { .remove pftp_matches.htbl }
      if ($exists(pftp_execlines.htbl)) { .remove pftp_execlines.htbl }
      if ($exists(pftp_bots.htbl)) { .remove pftp_bots.htbl }
      if ($exists(pftp_ignores.htbl)) { .remove pftp_ignores.htbl }
      if ($exists(pftp_nonconn_matches.htbl)) { .remove pftp_nonconn_matches.htbl }
      if ($exists(pftp_nonconn_ignores.htbl)) { .remove pftp_nonconn_ignores.htbl }
      if ($exists(pftp_notes.htbl)) { .remove pftp_notes.htbl }
      if ($exists(pftp_race_ignores.htbl)) { .remove pftp_race_ignores.htbl }
      if ($exists(pftp_race_chan_ignores.htbl)) { .remove pftp_race_chan_ignores.htbl }
      if ($pftp_init() == 0) {
         pftp_disp Script initialized...prepare to be amazed!
         set %PftpScriptActive YES
         set %PftpSession 0
         pftp_disp Script Active '/pftp stop' to deactivate.
      }
      else {
         pftp_disp Script initialization error, script may not funtion properly.
         pftp_disp Halting initialization! | halt
      }
   }
   elseif ($1 == race) {
      if (($2 == start) || ($2 == end)) {
         var %stats = $pftp_disp_race_stats($2,$3)
         if (%stats != $null) {
            echo -a $pftp_cfb(RACE $upper($2) INFO) $+ $chr(32) $+ $pftp_cfp($3) $+ $chr(32) $+ $pftp_cfb($chr(32) $+ %stats)
         }
         else {
            pftp_disp Sorry, couldn't find race $2 information for ' $+ $3 $+ ', please try again.
            halt
         }
      }
      elseif ($2 == all) {
         var %stats = $pftp_disp_race_stats(start,$3)
         if (%stats != $null) {
            echo -a $pftp_cfb(RACE START INFO) $+ $chr(32) $+ $pftp_cfp($3) $+ $chr(32) $+ $pftp_cfb($chr(32) $+ %stats)
         }
         else {
            pftp_disp Sorry, couldn't find race start information for ' $+ $3 $+ ', please try again.
            halt
         }
         var %stats = $pftp_disp_race_stats(end,$3)
         if (%stats != $null) {
            echo -a $pftp_cfb(RACE END INFO) $+ $chr(32) $+ $pftp_cfp($3) $+ $chr(32) $+ $pftp_cfb($chr(32) $+ %stats)
         }
         else {
            pftp_disp Sorry, couldn't find race end information for ' $+ $3 $+ ', please try again.
            halt
         }
      }
      elseif ($2 == clear) {
         pftp_disp Clearing race statistics tables...
         if ($hget(pftp_race_starts).size != 0) { hfree pftp_race_starts }
         if ($hget(pftp_race_ends).size != 0) { hfree pftp_race_ends }
         if ($exists(pftp_race_starts.htbl)) { .remove pftp_race_starts.htbl }
         if ($exists(pftp_race_ends.htbl)) { .remove pftp_race_ends.htbl }
         pftp_disp Race statistics cleared.
      }
      else {
         pftp_disp Command Syntax: /pftp race <clear|start|end|all> <release>
         pftp_disp Note: '/pftp race clear' clears all race stats (run every 100 releases)
         halt
      }
   }
   else {
      pftp_disp Command Syntax: /pftp <start|stop|rehash|race>
      halt
   }
}

;; init
alias pftp_init {
   pftp_sdisp Pftp Initializing settings...
   pftp_sdisp Loading general settings...
   if ($get_pftp_settings() == 0) {
      pftp_sdisp General settings loaded!
   }
   else { return 1 }
   pftp_sdisp Initializing tables...
   if ($init_pftp_tables() == 0) {
      pftp_sdisp Tables loaded and initialized
   }
   else { return 1 }
   pftp_sdisp Initializing custom aliases...
   if ($init_pftp_custom_aliases == 0) {
      pftp_sdisp Custom aliases initialized
   }
   else { return 1 }
   return 0
}

on *:start:{
   if ($pftp_init() == 0) {
      pftp_sdisp Script initialized...prepare to be amazed!
      set %PftpScriptActive YES
      pftp_disp Script Active '/pftp stop' to deactivate.

   }
   else {
      pftp_sdisp Script initialization error, script may not funtion properly.
      pftp_sdisp Halting initialization! | halt
   }
}

alias get_pftp_settings {
   if ($exists(pftp.ini)) {
      ;; server section
      set %PftpIp0 $readini(pftp.ini,n,server,ip0)
      set %PftpPort0 $readini(pftp.ini,n,server,port0)
      set %PftpIp1 $readini(pftp.ini,n,server,ip1)
      set %PftpPort1 $readini(pftp.ini,n,server,port1)
      set %PftpIp2 $readini(pftp.ini,n,server,ip2)
      set %PftpPort2 $readini(pftp.ini,n,server,port2)
      set %PftpIp3 $readini(pftp.ini,n,server,ip3)
      set %PftpPort3 $readini(pftp.ini,n,server,port3)
      set %PftpIp4 $readini(pftp.ini,n,server,ip4)
      set %PftpPort4 $readini(pftp.ini,n,server,port4)
      set %PftpAuthKey $readini(pftp.ini,n,server,authkey)
      set %PftpPassword $readini(pftp.ini,n,server,password)
      ;; script section
      set %PftpMatchesCS $readini(pftp.ini,n,script,cs_matches)
      set %PftpIgnoresCS $readini(pftp.ini,n,script,cs_ignores)
      set %PftpNonConnBeep $readini(pftp.ini,n,script,nonconn_beep)
      set %PftpWaveBeep $readini(pftp.ini,n,script,wave_beep)
      set %PftpMatchWave $readini(pftp.ini,n,script,match_wave)
      set %PftpNonConnWave $readini(pftp.ini,n,script,nonconn_wave)
      set %PftpMonitorWindow $readini(pftp.ini,n,script,monitor_window)
      set %PftpPostLaunchExec $readini(pftp.ini,n,script,post_launch_exec)
      set %PftpLaunchExec $readini(pftp.ini,n,script,launch_exec)
      set %PftpDisableAllConnect $readini(pftp.ini,n,script,disable_all_connect)
      set %PftpDisableAllAutoConnect $readini(pftp.ini,n,script,disable_all_auto_connect)
      return 0
   }
   else { pftp_sdisp Error: pftp.ini could not be found! Script not loaded. | return 1 }
}

;; init/check main tables
alias init_pftp_tables {
   ;; do matches table ($1 of matches in pftp.ini)
   if (($hget(pftp_matches).size == 0) && (!$exists(pftp_matches.htbl))) {
      hmake pftp_matches 100
      if ($exists(pftp.ini)) {
         var %i = 0
         var %totalitems = $ini(pftp.ini,matches,0)
         while (%totalitems != 0) {
            var %item = $gettok($readini(pftp.ini,n,matches,n $+ %i),1,32)
            if (%item != $null) {
               hadd pftp_matches %i %item
               dec %totalitems
            }
            inc %i
         }
      }
      else { pftp_sdisp Error: pftp.ini could not be found! Script not loaded. | return 1 }
      hsave -o pftp_matches pftp_matches.htbl
   }
   elseif (($hget(pftp_matches).size == 0) && ($exists(pftp_matches.htbl))) {
     hmake pftp_matches 100
     hload pftp_matches pftp_matches.htbl
   }
   else { continue }
   ;; do execlines table ($2- of matches in pftp.ini)
   if (($hget(pftp_execlines).size == 0) && (!$exists(pftp_execlines.htbl))) {
      hmake pftp_execlines 100
      if ($exists(pftp.ini)) {
         var %i = 0
         var %totalitems = $ini(pftp.ini,matches,0)
         while (%totalitems != 0) {
            var %item = $gettok($readini(pftp.ini,n,matches,n $+ %i),2-,32)
            if (%item != $null) {
               hadd pftp_execlines %i %item
               dec %totalitems
            }
            inc %i
         }
      }
      else { pftp_sdisp Error: pftp.ini could not be found! Script not loaded. | return 1 }
      hsave -o pftp_execlines pftp_execlines.htbl
   }
   elseif (($hget(pftp_execlines).size == 0) && ($exists(pftp_execlines.htbl))) {
     hmake pftp_execlines 100
     hload pftp_execlines pftp_execlines.htbl
   }
   else { continue }
   ;; do bots table
   if (($hget(pftp_bots).size == 0) && (!$exists(pftp_bots.htbl))) {
      hmake pftp_bots 10
      if ($exists(pftp.ini)) {
         var %i = 0
         var %totalitems = $ini(pftp.ini,bots,0)
         while (%totalitems != 0) {
            var %item = $readini(pftp.ini,n,bots,n $+ %i)
            if (%item != $null) {
               hadd pftp_bots %i %item
               dec %totalitems
            }
            inc %i
         }
      }
      else { pftp_sdisp Error: pftp.ini could not be found! Script not loaded. | return 1 }
      hsave -o pftp_bots pftp_bots.htbl
   }
   elseif (($hget(pftp_bots).size == 0) && ($exists(pftp_bots.htbl))) {
     hmake pftp_bots 10
     hload pftp_bots pftp_bots.htbl
   }
   else { continue }
   ;; do ignores table
   if (($hget(pftp_ignores).size == 0) && (!$exists(pftp_ignores.htbl))) {
      hmake pftp_ignores 20
      if ($exists(pftp.ini)) {
         var %i = 0
         var %totalitems = $ini(pftp.ini,ignores,0)
         while (%totalitems != 0) {
            var %item = $readini(pftp.ini,n,ignores,n $+ %i)
            if (%item != $null) {
               hadd pftp_ignores %i %item
               dec %totalitems
            }
            inc %i
         }
      }
      else { pftp_sdisp Error: pftp.ini could not be found! Script not loaded. | return 1 }
      hsave -o pftp_ignores pftp_ignores.htbl
   }
   elseif (($hget(pftp_ignores).size == 0) && ($exists(pftp_ignores.htbl))) {
     hmake pftp_ignores 20
     hload pftp_ignores pftp_ignores.htbl
   }
   else { continue }
   return 0
}

;; init custom aliases
alias init_pftp_custom_aliases {
   if ($exists(pftp.ini)) {
      var %file = pftp_custom_aliases.mrc
      if ($exists(%file)) { .remove %file }
      var %i = 0
      var %totalitems = $ini(pftp.ini,aliases,0)
      while (%totalitems != 0) {
         var %cmd = $gettok($readini(pftp.ini,n,aliases,n $+ %i),1,32)
         var %execargs = $gettok($readini(pftp.ini,n,aliases,n $+ %i),2-,32)
         if ((%cmd != $null) && (%execargs != $null)) {
            write %file $chr(47) $+ %cmd $+ $chr(32) $+ $chr(123)
            write %file pftp_disp Executing custom %cmd alias, see $chr(64) $+ pftp-server window for more info...
            if (-passwd !isin $execargs) { var %execargs = -passwd= $+ %PftpPassword $+ $chr(32) $+ %execargs }
            write %file put_pftp %execargs
            write %file $chr(125)
            dec %totalitems
         }
         inc %i
      }
      .reload -a %file
   }
   else { pftp_sdisp Error: pftp.ini could not be found! Script not loaded. | return 1 }
   return 0
}

;; init dupes table
alias init_pftp_dupe_table {
   var %lastdupe = $hget(pftp_dupes,$hget(pftp_dupes,0).item)
   if (($hget(pftp_dupes).size == 0) && (!$exists(pftp_dupes.htbl))) {
      hmake pftp_dupes 20
   }
   elseif (($hget(pftp_dupes).size == 0) && ($exists(pftp_dupes.htbl))) {
     hmake pftp_dupes 20
     hload pftp_dupes pftp_dupes.htbl
   }
   elseif (($hget(pftp_dupes).size != 0) && ($hget(pftp_dupes,0).item >= 50)) {
      hfree pftp_dupes
      if ($exists(pftp_dupes.htbl)) { .remove pftp_dupes.htbl }
      hmake pftp_dupes 20
   }
   else { continue }
   return %lastdupe
}

;; init nonconn matches table
alias init_pftp_nonconn_matches_table {
   if (($hget(pftp_nonconn_matches).size == 0) && (!$exists(pftp_nonconn_matches.htbl))) {
      hmake pftp_nonconn_matches 5
      if ($exists(pftp.ini)) {
         var %i = 0
         var %totalitems = $ini(pftp.ini,nonconn_matches,0)
         while (%totalitems != 0) {
            var %item = $readini(pftp.ini,n,nonconn_matches,n $+ %i)
            if (%item != $null) {
               hadd pftp_nonconn_matches %i %item
               dec %totalitems
            }
            inc %i
         }
      }
      else { pftp_sdisp Error: pftp.ini could not be found! Script not loaded. | return 1 }
      hsave -o pftp_nonconn_matches pftp_nonconn_matches.htbl
   }
   elseif (($hget(pftp_nonconn_matches).size == 0) && ($exists(pftp_nonconn_matches.htbl))) {
     hmake pftp_nonconn_matches 5
     hload pftp_nonconn_matches pftp_nonconn_matches.htbl
   }
   else { continue }
}

;; init nonconn ignores table
alias init_pftp_nonconn_ignores_table {
   if (($hget(pftp_nonconn_ignores).size == 0) && (!$exists(pftp_nonconn_ignores.htbl))) {
      hmake pftp_nonconn_ignores 5
      if ($exists(pftp.ini)) {
         var %i = 0
         var %totalitems = $ini(pftp.ini,nonconn_ignores,0)
         while (%totalitems != 0) {
            var %item = $readini(pftp.ini,n,nonconn_ignores,n $+ %i)
            if (%item != $null) {
               hadd pftp_nonconn_ignores %i %item
               dec %totalitems
            }
            inc %i
         }
      }
      else { pftp_sdisp Error: pftp.ini could not be found! Script not loaded. | return 1 }
      hsave -o pftp_nonconn_ignores pftp_nonconn_ignores.htbl
   }
   elseif (($hget(pftp_nonconn_ignores).size == 0) && ($exists(pftp_nonconn_ignores.htbl))) {
     hmake pftp_nonconn_ignores 5
     hload pftp_nonconn_ignores pftp_nonconn_ignores.htbl
   }
   else { continue }
}

;; init notes table
alias init_pftp_notes_table {
   if (($hget(pftp_notes).size == 0) && (!$exists(pftp_notes.htbl))) {
      hmake pftp_notes 5
      if ($exists(pftp.ini)) {
         var %i = 0
         var %totalitems = $ini(pftp.ini,notes,0)
         while (%totalitems != 0) {
            var %item = $readini(pftp.ini,n,notes,n $+ %i)
            if (%item != $null) {
               hadd pftp_notes %i %item
               dec %totalitems
            }
            inc %i
         }
      }
      else { pftp_sdisp Error: pftp.ini could not be found! Script not loaded. | return 1 }
      hsave -o pftp_notes pftp_notes.htbl
   }
   elseif (($hget(pftp_notes).size == 0) && ($exists(pftp_notes.htbl))) {
     hmake pftp_notes 5
     hload pftp_notes pftp_notes.htbl
   }
   else { continue }
}

alias init_pftp_race_ignores_table {
   if (($hget(pftp_race_ignores).size == 0) && (!$exists(pftp_race_ignores.htbl))) {
      hmake pftp_race_ignores 5
      if ($exists(pftp.ini)) {
         var %i = 0
         var %totalitems = $ini(pftp.ini,race_ignores,0)
         while (%totalitems != 0) {
            var %item = $readini(pftp.ini,n,race_ignores,n $+ %i)
            if (%item != $null) {
               hadd pftp_race_ignores %i %item
               dec %totalitems
            }
            inc %i
         }
      }
      else { pftp_sdisp Error: pftp.ini could not be found! Script not loaded. | return 1 }
      hsave -o pftp_race_ignores pftp_race_ignores.htbl
   }
   elseif (($hget(pftp_race_ignores).size == 0) && ($exists(pftp_race_ignores.htbl))) {
     hmake pftp_race_ignores 5
     hload pftp_race_ignores pftp_race_ignores.htbl
   }
   else { continue }
}

alias init_pftp_race_chan_ignores_table {
   if (($hget(pftp_race_chan_ignores).size == 0) && (!$exists(pftp_race_chan_ignores.htbl))) {
      hmake pftp_race_chan_ignores 5
      if ($exists(pftp.ini)) {
         var %i = 0
         var %totalitems = $ini(pftp.ini,race_chan_ignores,0)
         while (%totalitems != 0) {
            var %item = $readini(pftp.ini,n,race_chan_ignores,n $+ %i)
            if (%item != $null) {
               hadd pftp_race_chan_ignores %i %item
               dec %totalitems
            }
            inc %i
         }
      }
      else { pftp_sdisp Error: pftp.ini could not be found! Script not loaded. | return 1 }
      hsave -o pftp_race_chan_ignores pftp_race_chan_ignores.htbl
   }
   elseif (($hget(pftp_race_chan_ignores).size == 0) && ($exists(pftp_race_chan_ignores.htbl))) {
     hmake pftp_race_chan_ignores 5
     hload pftp_race_chan_ignores pftp_race_chan_ignores.htbl
   }
   else { continue }
}

;; init race_starts table
alias init_pftp_race_starts_table {
   if (($hget(pftp_race_starts).size == 0) && (!$exists(pftp_race_starts.htbl))) {
      hmake pftp_race_starts 50
   }
   elseif (($hget(pftp_race_starts).size == 0) && ($exists(pftp_race_starts.htbl))) {
     hmake pftp_race_starts 50
     hload pftp_race_starts pftp_race_starts.htbl
   }
   else { continue }
}

;; init race_ends table
alias init_pftp_race_ends_table {
   if (($hget(pftp_race_ends).size == 0) && (!$exists(pftp_race_ends.htbl))) {
      hmake pftp_race_ends 50
   }
   elseif (($hget(pftp_race_ends).size == 0) && ($exists(pftp_race_ends.htbl))) {
     hmake pftp_race_ends 50
     hload pftp_race_ends pftp_race_ends.htbl
   }
   else { continue }
}

;; post connect events
alias post_connect_events {
   if ((%PftpWaveBeep == 1) && ($exists(%PftpMatchWave))) {
      splay -cw %PftpMatchWave
   }
   else { beep 5 100 }
   if ((%PftpPostLaunchExec == 1) && (%PftpLaunchExec != $null)) {
      .run %PftpLaunchExec
   }
}

;; socket stuff (this is where it all comes together)
on *:sockopen:PftpSock.*:{
   if ($window(@pftp-server,status) == 0) { window -R +Le @pftp-server }
   if ($sockerr > 0) {
      var %wsmsg = $sock($sockname).wsmsg
      var %wserr = $sock($sockname).wserr
      echo -s wserr %wserr
      echo -s wsmsg %wsmsg
      aline -p 14 @pftp-server Error: Socket $sockname %wsmsg $+ , closing socket.
      sockclose $sockname
      if (%wserr == 10061) {
         set %PftpSession $calc(%PftpSession + 1)
         if (%PftpSession > 4) {
            aline -p 14 @pftp-server Error: Unable to open socket, maximum number of sessions reached. | return
         }
         aline -p 7 @pftp-server Opening PftpSock for writing ( $+ %PftpIp [ $+ [ %PftpSession ] ] $+ : $+ %PftpPort [ $+ [ %PftpSession ] ] $+ )
         sockopen PftpSock. [ $+ [ %PftpSession ] ] %PftpIp [ $+ [ %PftpSession ] ] %PftpPort [ $+ [ %PftpSession ] ]
         return
      }
   }
   else {
      aline -p 7 @pftp-server Sending: %PftpAuthKey %PftpArgs $+ ...
      sockwrite -n $sockname %PftpAuthKey %PftpArgs
      post_connect_events
   }
}

on *:sockread:PftpSock.*:{
   if ($sockerr > 0) {
      aline -p 14 @pftp-server Error: Socket $sockname $sock($sockname).wsmsg $+ , closing socket.
      sockclose $sockname
      return
   }
   :nextread
   sockread %line
   if ($sockbr == 0) {
      sockclose $sockname
      return
   }
   if (%line == $null) { %line = -- }
   if ($window(@pftp-server,status) == 0) { window -R +Le @pftp-server }
   aline -p 14 @pftp-server %line
   goto nextread
}

on *:sockclose:PftpSock.*:{
   if ($window(@pftp-server,status) == 0) { window -R +Le @pftp-server }
   aline -p 14 @pftp-server Connection closed by foreign host.
}

alias put_pftp {
   if (%PftpDisableAllConnect == 1) { post_connect_events | return }
   if (*passwd* !iswm $1-) {
      set %PftpArgs -passwd= $+ %PftpPassword $+ $chr(32) $+ $1-
   }
   else { set %PftpArgs $1- }
   set %PftpSession 0
   if ($sock(PftpSock. [ $+ [ %PftpSession ] ]) != $null) {
      set %PftpSession 1
      while ($sock(PftpSock. [ $+ [ %PftpSession ] ]) != $null) {
         set %PftpSession $calc(%PftpSession + 1)
         if (%PftpSession > 4) {
            if ($window(@pftp-server,status) == 0) { window -R +Le @pftp-server }
            aline -p 14 @pftp-server Error: Unable to open socket, maximum number of sessions reached. | return
         }
      }
   }
   if ($window(@pftp-server,status) == 0) { window -R +Le @pftp-server }
   aline -p 7 @pftp-server Opening PftpSock for writing ( $+ %PftpIp [ $+ [ %PftpSession ] ] $+ : $+ %PftpPort [ $+ [ %PftpSession ] ] $+ )
   sockopen PftpSock. [ $+ [ %PftpSession ] ] %PftpIp [ $+ [ %PftpSession ] ] %PftpPort [ $+ [ %PftpSession ] ]
}

;; alias check notes (for those with less than perfect memories)
alias pftp_check_notes {
   init_pftp_notes_table
   var %i = 0
   var %return = $null
   while ((%i < $hget(pftp_notes,0).item) && (%return == $null)) {
      if (%PftpMatchesCS == 1) {
         var %matchtok = $wildtokcs($1,$gettok($hget(pftp_notes,%i),1,32),1,32)
      }
      else {
         var %matchtok = $wildtok($1,$gettok($hget(pftp_notes,%i),1,32),1,32)
      }
      if (%matchtok != $null) {
         var %return = $gettok($hget(pftp_notes,%i),2-,32)
      }
      inc %i
   }
   return %return
}

;; dupecheck
alias pftp_dupecheck {
   var %lastdupe = $init_pftp_dupe_table()
   if ((*-* !iswm $1) || ((*-* !iswm $1) && ((cd* iswm $1) || (disc* iswm $1) || (covers* iswm $1) || (subs* iswm $1) || (sample* iswm $1)))) {
      return 1
   }
   elseif (($hget(pftp_dupes,0).item == 0) && (%lastdupe != $1)) {
      hadd pftp_dupes 1 $1
      hsave -o pftp_dupes pftp_dupes.htbl
      return 0
   }
   elseif (($hget(pftp_dupes,0).item == 0) && (%lastdupe == $1)) {
      hadd pftp_dupes 1 $1
      hsave -o pftp_dupes pftp_dupes.htbl
      return 1
   }
   else {
      var %i = $hfind(pftp_dupes,$1,1,n).data
      if ((%i != $null) && ($hget(pftp_dupes,%i) == $1)) {
         return 1
      }
      else {
         hadd pftp_dupes $calc($hget(pftp_dupes,0).item + 1) $1
         hsave -o pftp_dupes pftp_dupes.htbl
         return 0
      }
   }
   return 0
}

;; start/end tag checking
alias pftp_check_race_tags {
   init_pftp_race_chan_ignores_table
   var %chanignore = 0
   var %i = $hfind(pftp_race_chan_ignores,$1,1,n).data
   if (%i != $null) {
      if ($hget(pftp_race_chan_ignores,%i) == $1) {
         var %chanignore = 1
      }
   }
   if (%chanignore == 1) { return $null }
   init_pftp_race_ignores_table
   var %foundignore = 0
   var %i = $hfind(pftp_race_ignores,$4-,1,W).data
   if (%i != $null) {
      if (%PftpIgnoresCS == 1) {
         var %ignoretok = $wildtokcs($4-,$hget(pftp_race_ignores,%i),1,32)
      }
      else {
        var %ignoretok = $wildtok($4-,$hget(pftp_race_ignores,%i),1,32)
      }
      if (%ignoretok != $null) {
         var %foundignore = 1
      }
   }
   if (%foundignore == 1) { return $null }
   var %foundtag = 0
   var %tagtok = $null
   if ($2 != NULL) {
      if (%PftpMatchesCS == 1) {
         var %tagtok = $wildtokcs($4-,$2,1,32)
      }
      else {
         var %tagtok = $wildtok($4-,$2,1,32)
      }
      if (%tagtok != $null) {
         var %foundtag = 1
      }
   }
   if (%foundtag == 1) { return starts }
   var %foundtag = 0
   var %tagtok = $null
   if ($3 != NULL) {
      if (%PftpMatchesCS == 1) {
         var %tagtok = $wildtokcs($4-,$3,1,32)
      }
      else {
         var %tagtok = $wildtok($4-,$3,1,32)
      }
      if (%tagtok != $null) {
         var %foundtag = 1
      }
   }
   if (%foundtag == 1) { return ends }
   return $null
}

;; record race stats (release name with site names and times)
alias pftp_record_race_stats {
   var %ticks = $ticks
   var %time = $time
   if ($1 == starts) {
      init_pftp_race_starts_table
      var %data = $hget(pftp_race_starts,$3)
      if (%data != $null) {
         if ($2 isin %data) { return 1 }
         hadd pftp_race_starts $3 %data $+ $chr(124) $+ $2 $+ $chr(58) $+ %ticks
         hsave -o pftp_race_starts pftp_race_starts.htbl
         return 0
      }
      elseif (%data == $null) {
         hadd pftp_race_starts $3 $2 $+ $chr(58) $+ %ticks $+ $chr(58) $+ %time
         hsave -o pftp_race_starts pftp_race_starts.htbl
         return 0
      }
   }
   if ($1 == ends) {
      init_pftp_race_ends_table
      var %data = $hget(pftp_race_ends,$3)
      if (%data != $null) {
         if ($2 isin %data) { return 1 }
         hadd pftp_race_ends $3 %data $+ $chr(124) $+ $2 $+ $chr(58) $+ %ticks
         hsave -o pftp_race_ends pftp_race_ends.htbl
         return 0
      }
      elseif (%data == $null) {
         hadd pftp_race_ends $3 $2 $+ $chr(58) $+ %ticks $+ $chr(58) $+ %time
         hsave -o pftp_race_ends pftp_race_ends.htbl
         return 0
      }
   }
   return $null
}

;; output race stats in nice looking format
alias pftp_disp_race_stats {
   if ($1 == start) {
      init_pftp_race_starts_table
      var %table = pftp_race_starts
   }
   elseif ($1 == end) {
      init_pftp_race_ends_table
      var %table = pftp_race_ends
   }
   else { return 1 }
   var %line = $hget(%table,$2)
   if ($hget(race_stats).size != 0) {
      hfree race_stats
      hmake race_stats 10
   }
   else { hmake race_stats 10 }
   var %i = 1
   while ($gettok(%line,%i,124) != $null) {
      hadd race_stats %i $gettok(%line,%i,124)
      inc %i
   }
   var %i = 1
   var %output = $null
   while ($hget(race_stats,%i) != $null) {
      var %site = $gettok($hget(race_stats,%i),1,58)
      if (%i == 1) {
         var %startticks = $gettok($hget(race_stats,%i),2,58)
         var %time = $gettok($hget(race_stats,%i),3-,58)
      }
      else {
         var %ticks = $gettok($hget(race_stats,%i),2,58)
         var %time = $chr(43) $+ $calc($calc(%ticks - %startticks) / 1000) $+ s
      }
      var %output = %output $+ %i $+ $chr(46) $+ $chr(32) $+ %site $+ $pftp_cfp(%time) $+ $chr(160)
      inc %i
   }
   return %output
}

;; cleanup string to get release
alias pftp_get_release {
   var %return = $1
   if ($chr(42) $+ $chr(40) $+ $chr(42) iswm %return) {
      var %return = $gettok(%return,1,40)
   }
   if ($asc($mid(%return,0,1)) isin 39.40.41.44.45.46.91.93) {
      var %return = $right(%return,$calc($len(%return) - 1))
   }
   if ($asc($mid(%return,$len(%return),1)) isin 39.40.41.44.45.46.91.93) {
      var %return = $left(%return,$calc($len(%return) - 1))
   }
   if ($gettok($remove(%return,:,!),2,62) != $null) {
      var %return = $gettok($remove(%return,:,!),2,62)
   }
   if ($asc($mid(%return,0,1)) isin 39.40.41.44.45.46.91.93) {
      var %return = $right(%return,$calc($len(%return) - 1))
   }
   if ($asc($mid(%return,$len(%return),1)) isin 39.40.41.44.45.46.91.93) {
      var %return = $left(%return,$calc($len(%return) - 1))
   }
   if (CD* !iswm $remove($nopath(%return),:,!)) {
      var %return = $remove($nopath(%return),:,!)
   }
   else { var %return = $gettok($remove(%return,:,!),1,47) }
   return %return
}

;; main on text loop
on *:TEXT:*:#:{
   ;; make sure tables exist and are loaded
   init_pftp_tables
   ;; check if nick is bot; if not, halt
   var %uhost = $address($nick,5)
   var %isbot = 0
   var %i = $hfind(pftp_bots,%uhost,1,W).data
   if ((%i != $null) && ($hget(pftp_bots,%i) iswm %uhost)) {
      var %isbot = 1
      var %matchbot = $hget(pftp_bots,%i)
      var %bothost = %uhost
      var %sitename = $readini(pftp.ini,n,sites,n $+ %i)
      var %starttag = $readini(pftp.ini,n,start_tags,n $+ %i)
      var %endtag = $readini(pftp.ini,n,end_tags,n $+ %i)
      if (%sitename == $null) { var %sitename = $nick }
      if (%starttag == $null) { var %starttag = NULL }
      if (%endtag == $null) { var %endtag = NULL }
   }
   if (%isbot == 1) {
      var %bottext = $strip($1-)
      var %foundignore = 0
      var %i = $hfind(pftp_ignores,%bottext,1,W).data
      if (%i != $null) {
         if (%PftpIgnoresCS == 1) {
            var %ignoretok = $wildtokcs(%bottext,$hget(pftp_ignores,%i),1,32)
         }
         else {
            var %ignoretok = $wildtok(%bottext,$hget(pftp_ignores,%i),1,32)
         }
         if (%ignoretok != $null) {
            var %foundignore = 1
         }
      }
      var %puts = $null
      var %foundmatch = 0
      var %i = 0
      var %tmatches = $hget(pftp_matches,0).item
      while ((%tmatches != 0) && (%foundmatch == 0)) {
         var %currmatch = $hget(pftp_matches,%i)
         if (%currmatch != $null) {
            if (%PftpMatchesCS == 1) {
               var %matchtok = $wildtokcs(%bottext,%currmatch,1,32)
            }
            else {
               var %matchtok = $wildtok(%bottext,%currmatch,1,32)
            }
            if (%matchtok != $null) {
               var %foundmatch = 1
               var %release = $pftp_get_release(%matchtok)
               var %puts = $hget(pftp_execlines,%i)
               var %racetag = $pftp_check_race_tags($chan,%starttag,%endtag,%bottext)
               if (%racetag != $null) {
                  var %recorded = $pftp_record_race_stats(%racetag,%sitename,%release)
                  if (%recorded == 0) {
                     if ($window(@pftp-server,status) == 0) { window -R +Le @pftp-server }
                     aline -p 14 @pftp-server $pftp_cfb(%sitename) $+ $chr(32) $+ $pftp_cfp(%release) $+ $chr(32) $+ $replace(%racetag,starts,started,ends,finished) $+ $chr(32) $+ $chr(64) $+ $chr(32) $+ $time
                  }
               }
            }
            dec %tmatches
         }
         inc %i
      }
      if (%foundignore == 1) { halt }
      if ((%PftpScriptActive === YES) && (%foundmatch == 1) && ($pftp_dupecheck(%release) == 0)) {
         echo -a $pftp_cfb(%sitename) Release $pftp_cfp(%release) GO RACE $chr(64) $time
         if ($window(@pftp-server,status) == 0) { window -R +Le @pftp-server }
         if (%PftpDisableAllAutoConnect != 1) {
            aline -p 14 @pftp-server Launching Pftp...
            put_pftp %puts
         }
         else { post_connect_events }
         var %notes = $pftp_check_notes(%release)
         if (%notes != $null) {
            echo -a $pftp_cfb(%sitename) Release $pftp_cfp(%release) %notes
         }
         if (%PftpMonitorWindow == 1) {
            if ($window(@pftp-monitor,status) == 0) { window -dR +Le @pftp-monitor }
            aline -p @pftp-monitor $pftp_cfb(%sitename) Release $pftp_cfp(%release) GO RACE $chr(64) $time
         }
      }
      elseif ((%PftpScriptActive !=== YES) && (%foundmatch == 1) && ($pftp_dupecheck(%release) == 0)) {
         echo -a $pftp_cfb(%sitename) Release $pftp_cfp(%release) GO RACE (pftp launch not active) $chr(64) $time
         var %notes = $pftp_check_notes(%release)
         if (%notes != $null) {
            echo -a $pftp_cfb(%sitename) Release $pftp_cfp(%release) %notes
         }
         if (%PftpMonitorWindow == 1) {
            if ($window(@pftp-monitor,status) == 0) { window -dR +Le @pftp-monitor }
            aline -p @pftp-monitor $pftp_cfb(%sitename) Release $pftp_cfp(%release) GO RACE (pftp launch not active) $chr(64) $time
         }
         if ($window(@pftp-server,status) == 0) { window -R +Le @pftp-server }
         aline -p 14 @pftp-server Pftp launch not active...halting
      }
      elseif (%foundmatch != 1) {
         init_pftp_nonconn_ignores_table
         var %foundignore = 0
         var %i = $hfind(pftp_nonconn_ignores,%bottext,1,W).data
         if (%i != $null) {
            if (%PftpIgnoresCS == 1) {
               var %ignoretok = $wildtokcs(%bottext,$hget(pftp_nonconn_ignores,%i),1,32)
            }
            else {
               var %ignoretok = $wildtok(%bottext,$hget(pftp_nonconn_ignores,%i),1,32)
            }
            if (%ignoretok != $null) {
               var %foundignore = 1
            }
         }
         init_pftp_nonconn_matches_table
         var %foundmatch = 0
         var %i = 0
         var %tmatches = $hget(pftp_nonconn_matches,0).item
         while ((%tmatches != 0) && (%foundmatch == 0)) {
            var %currmatch = $hget(pftp_nonconn_matches,%i)
            if (%currmatch != $null) {
               if (%PftpMatchesCS == 1) {
                  var %matchtok = $wildtokcs(%bottext,%currmatch,1,32)
               }
               else {
                  var %matchtok = $wildtok(%bottext,%currmatch,1,32)
               }
               if (%matchtok != $null) {
                  var %foundmatch = 1
                  var %release = $pftp_get_release(%matchtok)
                  var %puts = $hget(pftp_execlines,%i)
                  var %racetag = $pftp_check_race_tags($chan,%starttag,%endtag,%bottext)
                  if (%racetag != $null) {
                     var %recorded = $pftp_record_race_stats(%racetag,%sitename,%release)
                     if (%recorded == 0) {
                        if ($window(@pftp-server,status) == 0) { window -R +Le @pftp-server }
                        aline -p 14 @pftp-server $pftp_cfb(%sitename) $+ $chr(32) $+ $pftp_cfp(%release) $+ $chr(32) $+ $replace(%racetag,starts,started,ends,finished) $+ $chr(32) $+ $chr(64) $+ $chr(32) $+ $time
                     }
                  }
               }
               dec %tmatches
            }
            inc %i
         }
         if (%foundignore == 1) { halt }
         if ((%foundmatch == 1) && ($pftp_dupecheck(%release) == 0)) {
            echo -a $pftp_cfb(%sitename) Release $pftp_cfp(%release) Non conection match $chr(64) $time
            if ((%PftpNonConnBeep == 1) && (%PftpScriptActive === YES)) {
               if ((%PftpWaveBeep == 1) && ($exists(%PftpNonConnWave))) {
                  splay -cw %PftpNonConnWave
               }
               else { beep 5 100 }
            }
            var %notes = $pftp_check_notes(%release)
            if (%notes != $null) {
               echo -a $pftp_cfb(%sitename) Release $pftp_cfp(%release) %notes
            }
            if (%PftpMonitorWindow == 1) {
               if ($window(@pftp-monitor,status) == 0) { window -dR +Le @pftp-monitor }
               aline -p @pftp-monitor $pftp_cfb(%sitename) Release $pftp_cfp(%release) Non Connection match $chr(64) $time
            }
         }
         else { halt }
      }
      else { halt }
   }
   else { halt }
}
